<?php

class client_profile_viewer_license_3257PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function client_profiler_viewer_config()
{
	client_profiler_viewer_loadAutoloader();
	$autoloader = new MG_CPV_Autoloader('MG_CPV_', client_profiler_viewer_getPathToFolderWithClasses());
	MG_CPV_Configuration::setConfigArray();
	$configarray = MG_CPV_Configuration::$configarray;
	$autoloader->unregister();
	return $configarray;
}

function client_profiler_viewer_output($params = array())
{
	$license_check = client_profile_viewer_license_3257();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	client_profiler_viewer_loadAutoloader();
	$autoloader = new MG_CPV_Autoloader('MG_CPV_', client_profiler_viewer_getPathToFolderWithClasses());
	$init = new MG_CPV_Init();
	$init->loadErrorHandler('admin');
	$init->initAA($params);
	$autoloader->unregister();
}

function client_profiler_viewer_activate($params = array())
{
	client_profiler_viewer_loadAutoloader();
	$autoloader = new MG_CPV_Autoloader('MG_CPV_', client_profiler_viewer_getPathToFolderWithClasses());
	$init = new MG_CPV_Init();
	$init->createDBTables();
	$autoloader->unregister();
}

function client_profiler_viewer_deactivate($params = array())
{
}

function client_profiler_viewer_upgrade($params = array())
{
	client_profiler_viewer_loadAutoloader();
	$autoloader = new MG_CPV_Autoloader('MG_CPV_', client_profiler_viewer_getPathToFolderWithClasses());
	$init = new MG_CPV_Init();
	$init->updateDBTables();
	$autoloader->unregister();
}

function client_profiler_viewer_loadAutoloader()
{
	if (!class_exists('MG_CPV_Autoloader')) {
		include_once dirname(__FILE__) . DIRECTORY_SEPARATOR . 'classes' . DIRECTORY_SEPARATOR . 'class.Autoloader.php';
	}
}

function client_profiler_viewer_getPathToFolderWithClasses()
{
	return dirname(__FILE__) . DIRECTORY_SEPARATOR . 'classes';
}

function client_profile_viewer_license_3257()
{

		return array('status' => 'Active', 'description' => 'Your module license is active.');

}

defined('DS') || define('DS', DIRECTORY_SEPARATOR);
defined('MAIN_WHMCS_DIR') || define('MAIN_WHMCS_DIR', dirname(dirname(dirname(dirname(__FILE__)))) . DS);
defined('MAIN_APP_DIR') || define('MAIN_APP_DIR', dirname(__FILE__) . DS);

?>
