{literal}
    <style>
        #add_widget, #add_role, #selected_roles i, #selected_widgets i {
            cursor: pointer;
        }
        
        .icon-remove {
            cursor: pointer;
        }
        
        #add_role, #add_widget, a.remove {
            width: 65px;
        }
        
    </style>
{/literal}
<div id="create-form">
<div class="row">
    <div class="span12">
            <h3>{$_lang.add_new_configuration}</h3>
    </div>
</div>
<div class="row">
    <div class="span12">
            <form class="form-horizontal">
                <fieldset>
                    <div class="control-group">
                        <label class="control-label" for="input01">{$_lang.configuration_name}</label>
                        <div class="controls">
                            <input type="text" name="name" class="input" id="input01"
                                   data-mv-validator="required" data-mv-validator-msg="{$_lang.this_field_is_required}"
                                   style="width: 286px;">
                        </div>
                    </div>

                    <div class="control-group">
                        <label class="control-label" for="role_select">{$_lang.add_role}</label>
                        <div class="controls">
                            <select id="role_select">
                            {if $admin_roles}
                                {foreach from=$admin_roles item=it}
                                    <option value="{$it.id}">{$it.name}</option>
                                {/foreach}
                            {else}
                                <option>{$_lang.no_more_options}</option>
                            {/if}
                            </select> <a class="btn btn-success" id="add_role"><i class="icon-plus icon-white"></i> {$_lang.add}</a>
                            <span class="help-block">{$_lang.role_help}</span>
                        </div>
                    </div>

                    <div class="control-group">
                        <label class="control-label" for="input01">Roles Selected</label>
                        <div class="controls" id="selected_roles">
                            -
                        </div>
                    </div>

                    <div class="control-group">
                        <label class="control-label" for="widget_select">{$_lang.add_widget}</label>
                        <div class="controls">
                            <select id="widget_select">
                            {foreach from=$basic_widget_list item=it}
                                <option value="{$it.class}">{$it.name}</option>
                            {/foreach}
                            {foreach from=$custom_widget_list item=it}
                                <option value="{$it.class}">{$it.name}</option>
                            {/foreach}
                            </select> <a class="btn btn-success" id="add_widget"><i class="icon-plus icon-white"></i> {$_lang.add}</a>
                        </div>
                    </div>
                </fieldset>
            </form>
    </div> 
</div>
<div class="row">
    <div id="widgets-container" class="span12">
        
    </div>
</div>
                            
<div class="">
    <a data-act="create" data-raw="1" data-formid="create-form" class="btn btn-primary">{$_lang.create}</a>
    <a class="btn btn-default" data-act="index" data-subpage="" data-noloader="1">{$_lang.cancel}</a>
</div>
</div>
    
{literal}
    <script type="text/javascript">
{/literal}
        var LANG_REMOVE = "{$_lang.remove}";
        var LANG_NO_MORE_OPTIONS = "{$_lang.no_more_options}";
{literal}
        $(document).ready( function() {
            $('#widgets-container').sortable();
            
            $("#add_role").on('click', function() {
                addOptionToList($("#role_select"),$("#selected_roles"),'roles');
            });
            
            $("#selected_roles").delegate("a.remove", 'click', function() {
                removeOptionFromList($(this), $("#selected_roles"), $("#role_select"));
            });
            
            $("#add_widget").on('click', function() {
                var select = $("#widget_select");
                var outerHTML = $("<div />").append($('option:selected', select).clone()).html();
                var widget = select.val();
                if($("option:selected", select).text() == LANG_NO_MORE_OPTIONS) return;
                $("option:selected", select).remove();
                if($("option", select).length == 0) {
                    select.append('<option>'+LANG_NO_MORE_OPTIONS+'</option>');
                }
                if(widget === null) return;
                $.ajax({
                    type: "POST",
                    url: 'addonmodules.php?module=client_profiler_viewer&page=profiler&ajax=1&act=configuration&ajax=1' ,
                    data: {widget: widget} ,
                    //async: false
                }).done(function (ret) {
                    var obj = $.parseJSON(ret);
                    if(obj.result) {
                        var div = '<div class="widget-output">'
                           + '<input type="hidden" value="'+ widget +'" name="widgets[]">'
                           + '<span class="hide option">'+outerHTML+'</span>'
                           + obj.action.output.configuration
                           + '</div>';
                        $('#widgets-container').append(div);
                    }
                });
                //addOptionToList($("#widget_select"),$("#selected_widgets"),'widgets');
            });
            
            $("#widgets-container").delegate(".icon-remove", 'click', function() {
                var parent = $(this).parents(".widget-output").first();
                var html = parent.children('span.option').html();
                if($("#widget_select option:selected").text() == LANG_NO_MORE_OPTIONS) {
                    $("#widget_select option:selected").remove();
                }
                $("#widget_select").append(html);
                parent.remove();
                //removeOptionFromList($(this), $("#selected_widgets"), $("#widget_select"));
            });
        });
        
        function addOptionToList(select, list, options_name) {
            var val = select.val();
            if(val === null) return;
            var text = $("option:selected", select).text();
            if(text == LANG_NO_MORE_OPTIONS) return;
            var outerHTML = $("<div />").append($('option:selected', select).clone()).html();
            $("option:selected", select).remove();
            if($("option", select).length == 0) {
                select.append('<option>'+LANG_NO_MORE_OPTIONS+'</option>');
            }
            var len = $("li", list).length;
            var li = "<li><span style=\"width: 300px; display: inline-block;\">" + text +"</span> <a class=\"btn btn-danger remove\"><i class=\"icon-remove icon-white\"></i> "+LANG_REMOVE+"</a><span class=\"hide option\">"+outerHTML+
                    "</span><input type=\"hidden\" value=\""+val+"\" name=\""+options_name+"[]\"></li>";
            if( len !== 0 ) {
                list.append(li);
            } else {
                list.html(li);
            }
        }
        
        function removeOptionFromList(item, list, select) {
            if($("option:selected", select).text() == LANG_NO_MORE_OPTIONS) {
                $("option:selected", select).remove();
            }
            var option = item.parents('li').first().children('span.option').html();
            select.append(option);
            item.parents('li').first().remove();

            if( $('li', list).length == 0){
                 list.html("-");
            }
        }
        
    </script>
    
{/literal}