var is_ajax_action = false;
var timer;
var current_tab;
var jobtimer = false;

$.extend({
  getUrlVars: function(){
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
      hash = hashes[i].split('=');
      vars.push(hash[0]);
      vars[hash[0]] = hash[1];
    }
    return vars;
  },
  getUrlVar: function(name){
    return $.getUrlVars()[name];
  }
});

$( document ).ready(function() {
    $('<img/>')[0].src = "../modules/addons/client_profiler_viewer/views/assets/images/loadingsml.gif"; //preload
    //$(".whmcscontainer .contentpadded div").first().remove();
    
    $("#modal-frame").on('click', "#asub", function( e ) {
        var form = $(this).closest("form");
        var data = form.serialize() + "&ajax=1";
        var path = location.pathname + location.search;
        
        $.ajax({
            type: "GET",
            data: data,
            url: path,
            async: false
        })
        .done(function( ret ) {
            var obj = $.parseJSON( ret );
        });
    });
    
    setStatesColours();
    $("#mg-wrapper .datatable").dataTable();
    
    $("#mg-wrapper").on('click', "[data-act]:not(.disabled)", function( e ) {
        
        //if(is_ajax_action) return;
        is_ajax_action = true;
        var act_obj = $(this);
        var confirm = $(this).data("confirm");
        if(typeof confirm != 'undefined') {
             $( "#dialog-"+confirm+"-confirm" ).dialog({
                modal: true,
                buttons: {
                    "Confirm": function() {
                        doAction(act_obj);
                        $( this ).dialog( "close" );
                    },
                    Cancel: function() {
                        $( this ).dialog( "close" );
                    }
                }
            });
        } else {
            doAction(act_obj);
        }
        
    });
    
    $("#mg-modal").on('keyup', ':input.mv-validate', function() {
        miniValidator($("#mg-modal"));
    });
});

function setStatesColours() {
    $("#mg-wrapper .state").each(function() {
        var state = $(this).html().toLowerCase().trim();

        if( state == "stopped" || state == "disabled") {
            $(this).css('color','#EE2233');
        } else if( state == "running" || state == "enabled") {
            $(this).css('color','#44EE44');
        } else {
            $(this).css('color','#2222EE');
        }
    });
}

function setContainer(html) {
    $("#mg-container").html(html);
}

function setJobContainer(html) {
    $("#mg-jobs").html(html);
    $("#mg-wrapper .datatable").dataTable();
}

function setAlerts(error, info) {
    var element = $(error + info);
    $("#mg-error-container").html(element);
    if(error.length + info.length > 0) $('html,body').animate({scrollTop: $("#mg-error-container").offset().top - 20});
    setTimeout( function(){
        $(element).fadeOut('slow', function() {
            element.remove();
        });
    } , 5000);
}

function setModalError(error) {
    var element = $(error);
    $("#mg-modal div.modal-body").prepend(element);
    setTimeout( function(){
        $(element).fadeOut('slow', function() {
            element.remove();
        });
    } , 10000);
}

function appendLoader(obj) {
    //$('body').css('cursor', 'progress !important');
    obj.addClass('disabled');
    var loader_html = "<img id=\"mg_loader\" style=\"margin-left: 5px; text-align: center; \" src=\"../modules/addons/client_profiler_viewer/views/assets/images/loadingsml.gif\" />" ;
    $(loader_html).load( function() {
        if(!obj.parents('table').length && !obj.children('img').length) {
            obj.append(loader_html);
        }
    })
    
}

function removeLoader() {
  //  $('body').css('cursor', 'default');
    $("#mg_loader").parent('a').removeClass('disabled');
    $("#mg_loader").remove();
}

function setAndOpenModal(html) {
    $("#mg-modal").html(html);
    $("#mg-modal").modal();
}

function closeModal() {
    $("#mg-modal").modal('hide')
}

function preparePath($oldvars, $newvars) {
    
}

function doAction( obj ) {
    var current_tab = '';

    var act = obj.data("act");
    
    var pathArray = queryToArray(location.search.substring(1));
    pathArray['act'] = act;

    var noloader = obj.data("noloader");
    if(typeof noloader == 'undefined') {
        appendLoader(obj);
    }

    var refresh = obj.data("refresh");
    if(typeof refresh != 'undefined') {
        pathArray['_refresh'] = 1;
    }

     var rawData = '';

    var modal = false;
    if(obj.parents("#mg-modal").length == 1) {
        modal = true;
        
        if(typeof obj.data("raw") != "undefined") {
            rawData = $('#mg-modal :input').serialize();
        } else {
            pathArray = $.extend({}, pathArray, queryToArray($('#mg-modal :input').serialize()));
        }
        
        if(!miniValidator($("#mg-modal"))) {
            removeLoader();
            return 0;
        }
    }

    var formid = obj.data("formid");
    if(typeof formid != 'undefined') {
        if(typeof obj.data("raw") != "undefined") {
            rawData = $('#' + formid + ' :input').serialize();
        } else {
            var pathArray = $.extend({}, pathArray, queryToArray($('#' + formid + ' :input').serialize()));
        }
    }

    var additional_query = obj.data("query");
    if(typeof additional_query != 'undefined' && additional_query.length > 0) {
        var pathArray = $.extend({}, pathArray, queryToArray(additional_query));
    }

    var subpage = obj.data('subpage');
    var page = obj.data('page');
    
    if(typeof subpage != 'undefined' || typeof page != 'undefined') {
        (typeof page == 'undefined')?0:pathArray['page']    = page;
        (typeof subpage == 'undefined')?0:pathArray['subpage'] = subpage;
        location.search = arrayToQuery(pathArray);
    } else {
        pathArray['ajax'] = 1;
        $.ajax({
            type: "POST",
            url: location.pathname + '?ajax=1' ,
            data: arrayToQuery(pathArray) + '&' + rawData ,
            //async: false
        })
        .done(function( ret ) {
            var obj = $.parseJSON( ret );

            if(obj.result == 1) {

                if(typeof obj.action.refreshhtml != 'undefined') {
                    current_tab = $("#mg-tab li.active a").attr('href');
                    setContainer(obj.action.refreshhtml);
                    $("#mg-wrapper .datatable").dataTable();
                }

                if(typeof obj.action.output.modalhtml != 'undefined') {
                    setAndOpenModal(obj.action.output.modalhtml);
                }
                
                if(typeof obj.action.output.open_window != 'undefined') {
                    openNewWindow(obj.action.output.open_window);
                }
                
                if(typeof obj.action.output.go_to != 'undefined') {
                    goToPage(obj.action.output.go_to);
                }
                
                if(modal) {
                    if(obj.action.error.length) {
                        setModalError(obj.action.error);
                    } else {
                        closeModal();
                        setAlerts(obj.action.error, obj.action.info);
                    }
                } else {
                    setAlerts(obj.action.error, obj.action.info);
                }
            } else {
                alert(obj.errormsg);
            }
            
            
        })
        .always(function() {
            $("#mg-tab li a[href='"+current_tab+"']").tab('show');
            removeLoader();
            is_ajax_action = false;
        });
    }
}

function goToPage(search) {
    location.search = search;
}

function openNewWindow(url) {
    var newwindow = window.open(url,'vm','height=500,width=800');
    if (window.focus) {newwindow.focus()}
}


function queryToArray(query) {
    var queryParameters = {}, queryString = query, re = /([^&=]+)=([^&]*)/g, m;
    
    while (m = re.exec(queryString)) {
        if(typeof m[2] == 'string') {
            m[2] = m[2].replace(/\+/g," ").replace(/%2b/g,'+')
        }
        queryParameters[decodeURIComponent(m[1])] = decodeURIComponent(m[2]);
    }
    return queryParameters;
}

function arrayToQuery(array) {
    return $.param(array);
}

//==========================VALIDATOR===========================================
function miniValidator(obj) {
    var validate = true;
    
    $('div.control-group:not(.hide) :input', obj).each( function() {
        var input_validate = true;
        var input = $(this);
        input.addClass('mv-validate');
        var validators = input.data('mv-validator');
        var validator_msg = input.data('mv-validator-msg');
        if(typeof validators == 'undefined' || typeof validator_msg == 'undefined' ) {
            miniValidatorChecked(input);
            return ;
        }
        
        var validators_array = validators.split(",");
        
        $.each(validators_array, function(i, validator) {
            
            switch(validator.trim()) {
                case 'required':
                    if(input.val().length == 0) {
                        input_validate = false;
                    } 
                    break;
                case 'ip':
                    var cidr_ip_regexp = /^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/;
                    if(!input.val().match(cidr_ip_regexp)) {
                        input_validate = false;
                    }
                    break;
                case 'cidr':
                    var cidr_ip_regexp = /^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\/[0-9]{1,2}$/;
                    if(!input.val().match(cidr_ip_regexp)) {
                        input_validate = false;
                    } 
                    break;   
                case 'netmask':
                    var netmask_regexp = /^((128|192|224|240|248|252|254)\.0\.0\.0)$|(255\.(((0|128|192|224|240|248|252|254)\.0\.0)$|(255\.(((0|128|192|224|240|248|252|254)\.0)$|255\.(0|128|192|224|240|248|252|254)))))$/;
                    if(!input.val().match(netmask_regexp)) {
                        input_validate = false;
                    }
                    break;
                case 'rfc1918':
                    var rfc1918=/(10|192\.168|172\.(1[6-9]|2[0-9]|3[01]))\./;
                    if(!input.val().match(rfc1918)) {
                        input_validate = false;
                    } 
                    break;
                case 'number':
                    if(!input.val().match(/^[0-9]{1,}$/)) {
                        input_validate = false;
                    }
                    break;
            }
        });
        
        if(!input_validate) {
            miniValidatorMsg(input, validator_msg);
            validate = false;
        } else {
            miniValidatorChecked(input);
        }
        
        
    });
    
    return validate;
}

function miniValidatorMsg(obj, msg) {
    if(obj.parent().children("span.help-inline").length == 0) {
        var html = '<span class="help-inline">' + msg + '</span>';
        obj.parent().append(html);
        obj.parents('div.control-group').first().removeClass('success');
        obj.parents('div.control-group').first().addClass('error');
    }
}

function miniValidatorChecked(obj) {
    obj.parent().children('span.help-inline').first().remove();
    obj.parents('div.control-group').first().removeClass('error');
    obj.parents('div.control-group').first().addClass('success');
    
}
